searchNodes=[{"doc":"Provides a simple to use profiling mechanism to inspect the behavior of an application on a target VM. Under the hood it utilizes Erlang's profiler tools, namely eprof , the default, fprof or cprof . This runs as a stand-alone escript for both for ease of use and to minimize impact on the target VM. Overview The ezprofiler utilty presents the user with two types of profiling, both controlled via a simple shell-type interface. Process Profiling Attach the profiler to specific processes, registered names or pg/pg2 groups. When profiling starts those processes will be traced. The selection of pg vs pg2 is based on the OTP release, see @pg_otp_version in lib/ezprofiler/term_helper.ex if you wish to change that behavior. Code Profiling The process option can be omitted. Instead the code can be decorated with profiling start/stop functions. In this case, to simplify the analysis, only a single (the first) process to git that code block will be monitored. This is useful in, for example, web-based applications where 100's of processes maybe spawned and invoke the same code at the same time. Process Profiling This is when you know the process that you want to profile, the process is specified as a pid, registered name or PG2 group. The process or processes are specified with the command line option --processes . This coupled with the --sos (set on spawn) option can profile a process and carry on the profiling on all processes that are spawned by the target process. Included is the option to specify :ranch in the --processes option. This makes tracing of the popular Ranch socket acceptor pool, and specified with the --sos and --sol options will follow the spawned processes that are created on an inbound TCP accept requests. The list of processes can be a simple process id, a registered name, pg/pg2 group or a list. THey must be enclosed in double quotes, for example: --processes &quot;&lt;0.1278.0&gt;&quot; --processes &quot;:my_reg_name&quot; --processes &quot;[:ranch, &lt;0.777.0&gt;, :my_reg_name, {:xyz, :server_a_pg2}]&quot; For example: $ ./ezprofiler --node myapp@localhost --processes :my_reg_pid --sos --mf &quot;_:_&quot; Options: &#39;s&#39; to start profiling when &#39;waiting&#39; &#39;a&#39; to get profiling results when &#39;profiling&#39; &#39;r&#39; to abandon (reset) profiling and go back to &#39;waiting&#39; state with initial value for &#39;u&#39; set &#39;c&#39; to enable code profiling (once) &#39;c&#39; &quot;label&quot;to enable code profiling (once) for label (an atom), e.g. &quot;c special_atom&quot; &#39;u&#39; &quot;M:F&quot; to update the module and function to trace (only with eprof) &#39;v&#39; to view last saved results file &#39;g&#39; for debugging, returns the state on the target VM &#39;h&#39; this help text &#39;q&#39; to exit waiting..(1)&gt; Profiling has currently not started. The user selects 's' to commence profiling: waiting .. ( 1 ) &gt; s waiting .. ( 2 ) &gt; profiling ( 2 ) &gt; The utility is now profiling as seen by the change in prompt, when ready to get the results select 'a' for analyze. profiling ( 2 ) &gt; profiling ( 2 ) &gt; a * * * * * * Process &lt; 9272.3831 . 0 &gt; -- 62.53 % of profiled time * * * FUNCTION CALLS % TIME [ uS / CALLS ] -- -- -- -- -- -- - -- -- -- - -- -- [ -- -- -- -- -- ] &#39;Elixir.Ecto.Adapters.Postgres.Connection&#39; :query / 4 1 0.00 0 [ 0.00 ] &#39;Elixir.DBConnection&#39; :&#39;-transaction/3-fun-2-&#39; / 4 1 0.00 0 [ 0.00 ] &#39;Elixir.DBConnection&#39; :&#39;-execute/4-fun-0-&#39; / 5 1 0.00 0 [ 0.00 ] &#39;Elixir.DBConnection&#39; :&#39;-commit/3-fun-0-&#39; / 3 1 0.00 0 [ 0.00 ] &#39;Elixir.DBConnection&#39; :&#39;-begin/3-fun-0-&#39; / 3 1 0.00 0 [ 0.00 ] &#39;Elixir.Inspect.Atom&#39; :color_key / 1 1 0.00 0 [ 0.00 ] &#39;Elixir.Ecto.Queryable.Ecto.Query&#39; :to_query / 1 1 0.00 0 [ 0.00 ] &#39;Elixir.Ecto.Repo.Queryable&#39; :postprocessor / 4 1 0.00 0 [ 0.00 ] &#39;Elixir.Proto.Notification.AuthResponse&#39; :new / 0 1 0.00 0 [ 0.00 ] cow_http_hd :token_ci_list / 2 1 0.00 0 [ 0.00 ] &#39;Elixir.Postgrex.DefaultTypes&#39; :decode_rows / 4 2 0.00 0 [ 0.00 ] &#39;Elixir.Postgrex.DefaultTypes&#39; :&#39;-encode_params/3-anonymous-2-&#39; / 2 1 0.00 0 [ 0.00 ] lists :keystore / 4 2 0.00 0 [ 0.00 ] ... ... SNIP ... ... &#39;Elixir.Enum&#39; :&#39;-reduce/3-lists^foldl/2-0-&#39; / 3 445 8.73 235 [ 0.53 ] erts_internal :port_control / 3 3 17.69 476 [ 158.67 ] -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - -- -- - -- -- -- - -- -- [ -- -- -- -- -- ] Total : 3042 100.00 % 2691 [ 0.88 ] waiting .. ( 3 ) &gt; waiting .. ( 3 ) &gt; This can produce a lot of output since the --mf option was a wildcard. It's possible to focus in on a specific module and function and repeat. For example select the Erlang lists module. waiting .. ( 4 ) &gt; u lists :_ Updated the module and function waiting .. ( 5 ) &gt; s waiting .. ( 6 ) &gt; profiling ( 6 ) &gt; a profiling ( 7 ) &gt; * * * * * * Process &lt; 9272.3882 . 0 &gt; -- 48.30 % of profiled time * * * FUNCTION CALLS % TIME [ uS / CALLS ] -- -- -- -- -- -- - -- -- -- - -- -- [ -- -- -- -- -- ] lists :prefix / 2 7 0.09 2 [ 0.29 ] lists :keystore / 4 2 0.09 2 [ 1.00 ] lists :foreach / 2 6 0.13 3 [ 0.50 ] lists :keystore2 / 4 9 0.17 4 [ 0.44 ] lists :member / 2 5 0.17 4 [ 0.80 ] lists :reverse / 2 23 0.73 17 [ 0.74 ] lists :foldl / 3 42 0.90 21 [ 0.50 ] lists :reverse / 1 105 1.28 30 [ 0.29 ] lists :keymember / 3 4 1.62 38 [ 9.50 ] lists :keyfind / 3 133 94.83 2220 [ 16.69 ] -- -- -- -- -- -- -- -- - -- -- - -- -- -- - -- -- [ -- -- -- -- -- ] Total : 336 100.00 % 2341 [ 6.97 ] If specified with the --directory option the results can be saved and the last set of results can be re-displayed by pressing 'v' (see below). NOTE: If fprof is selected as the profiler the results will not be output to screen unless 'v' is selected. Code Profiling This permits the profiling of code dynamically. The user can decorate functions or blocks of code, and when ready the user can, from the escript, start profiling that function or block of code. The decorating is quite simple, the file priv/ezcodeprofiler.ex should be included in your application. This module ( EZProfiler.CodeProfiler ) contains stub functions that you can place throughout your code that have zero run-time cost. When the profiler connects to your application this code is hot-swapped out for a module with the same name, containing the same fucntion names. These functions contain actual working code. The run-time cost is stil minimal as only a single process will be monitored at a time. Once ezprofiler terminates the original &quot;stub&quot; module is restored to once again enuring zero run-time cost. For example, this will profile anything between start_code_profiling/0 and stop_code_profiling/0 def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . start_code_profiling ( ) bar ( x ) baz ( y ) EZProfiler.CodeProfiler . stop_code_profiling ( ) end This will just profile a specific function def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; bar / 1 , [ x ] ) end Or with a label / anonymous function: def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; bar / 1 , [ x ] , :my_label ) end def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; bar / 1 , [ x ] , fn -&gt; if should_i_profile? ( foo ) , do : :my_label , else : :nok end ) end Or in a pipelne: def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; baz / 1 , [ x ] ) |&gt; function2 ( ) end Invoke ezprofiler as below (no need for a process) hitting c will start profiling in this case. Code profiling still supports the --mf option (or u on the menu) to filter the results. $ ./ezprofiler --node myapp@localhost Options: &#39;s&#39; to start profiling when &#39;waiting&#39; &#39;a&#39; to get profiling results when &#39;profiling&#39; &#39;r&#39; to abandon (reset) profiling and go back to &#39;waiting&#39; state with initial value for &#39;u&#39; set &#39;c&#39; to enable code profiling (once) &#39;c&#39; &quot;label&quot;to enable code profiling (once) for label (an atom), e.g. &quot;c mylabel&quot; &#39;u&#39; &quot;M:F&quot; to update the module and function to trace (only with eprof) &#39;v&#39; to view last saved results file &#39;g&#39; for debugging, returns the state on the target VM &#39;h&#39; this help text &#39;q&#39; to exit waiting..(1)&gt; c waiting..(2)&gt; Code profiling enabled waiting..(2)&gt; Got a start profiling from source code with label of :no_label waiting..(2)&gt; profiling(2)&gt; profiling(2)&gt; ****** Process &lt;9500.793.0&gt; -- 100.00 % of profiled time *** FUNCTION CALLS % TIME [uS / CALLS] -------- ----- ------- ---- [----------] &#39;Elixir.MyServer.CommitLog.Protocol.Encoder.Server.Types.UserInfo&#39;:encode/1 5 0.00 0 [ 0.00] &#39;Elixir.MyServer.Subscriber.Notification&#39;:new/3 1 0.00 0 [ 0.00] ...SNIP... A label can be set as follows: EZProfiler.CodeProfiler . start_code_profiling ( :my_label ) case do_send_email ( email , private_key ) do :ok -&gt; EZProfiler.CodeProfiler . stop_code_profiling ( ) Then: waiting .. ( 4 ) &gt; c my_label waiting .. ( 5 ) &gt; Code profiling enabled with a label of :my_label waiting .. ( 5 ) &gt; Got a start profiling from source code with label of :my_label Alternatively the label can be replaced with a lambda that should return a label (atom) if tracing is to be started, or the atom :nok if it isn't: EZProfiler.CodeProfiler . start_code_profiling ( fn -&gt; if should_i_profile? ( foo ) , do : :my_label , else : :nok end ) case do_send_email ( email , private_key ) do :ok -&gt; EZProfiler.CodeProfiler . stop_code_profiling ( ) Compiling Execute mix escript.build Usage ezprofiler -- help ezprofiler : -- node [ node ] : the Erlang VM you want tracing on ( e . g . myapp @localhost ) -- cookie [ cookie ] : the VM cookie ( optional ) -- processes [ pid or reg_name ] : the remote process pid ( e . g . &quot;&lt;0.249.0&gt;&quot; ) or registered name you want to trace ( other options ranch or pg / pg2 group ) -- sos : if present will apply tracing to any process spawned by the one defined in -- process -- mf [ string ] : a specification of module :fun of which module and functions to trace , with underscore _ as a wildcard . Example &quot;Foo:bar&quot; will trace calls to Foo :bar &quot;Foo:_&quot; will trace calls to all functions in module Foo ( default is &quot;_:_&quot; ) -- directory : where to store the results -- maxtime : the maximum time we allow profiling for ( default 60 seconds ) -- profiler : one of eprof , cprof or fprof , default eprof -- sort : for eprof one of time , calls , mfa ( default time ) , for fprof one of acc or own ( default acc ) . Nothing for cprof -- help : this page","ref":"EZProfiler.html","title":"EZProfiler","type":"module"},{"doc":"This module handles code profiling. The user hits 'c' or 'c label' and any process whose code calls the function 'EZCodeProfiler.start_profiling' will be profiled until 'EZCodeProfiler.stop_profiling` is called. Only a single process at a time can be profiled. Other profiling functions allow for pipe profiling and function profiling. The module is loaded from the escript, replacing the one in the release, the reverse happens when the escript terminates. The module in the release has functions like: def start_profiling() do end So they are all no-ops with no run-time cost. There is a minimal run-time cost when the module is loaded, as much as a message to an Agent.","ref":"EZProfiler.CodeProfiler.html","title":"EZProfiler.CodeProfiler","type":"module"},{"doc":"Profiles a specific function Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; bar / 1 , [ x ] ) end","ref":"EZProfiler.CodeProfiler.html#function_profiling/2","title":"EZProfiler.CodeProfiler.function_profiling/2","type":"function"},{"doc":"Starts profiling a function using label (atom) or an anonymous function to target the results. Example (atom) def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; bar / 1 , [ x ] , :my_label ) end Example (anonymous function) def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; bar / 1 , [ x ] , fn -&gt; if should_i_profile? ( y ) , do : :my_label , else : :nok end ) end Then in the ezprofiler console: waiting .. ( 4 ) &gt; c my_label waiting .. ( 5 ) &gt; Code profiling enabled with a label of :my_label waiting .. ( 5 ) &gt; Got a start profiling from source code with label of :my_label NOTE: If anonymous function is used it must return an atom (label) to allow profiling ot the atom :nok to not profile.","ref":"EZProfiler.CodeProfiler.html#function_profiling/3","title":"EZProfiler.CodeProfiler.function_profiling/3","type":"function"},{"doc":"Starts profiling a function in a pipe. Example def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; baz / 1 , [ x ] ) |&gt; function2 ( ) end NOTE: It is advisable to filter results with --mf or the u option in the ezprofiler console","ref":"EZProfiler.CodeProfiler.html#pipe_profiling/3","title":"EZProfiler.CodeProfiler.pipe_profiling/3","type":"function"},{"doc":"Starts profiling a function in a pipe using label (atom) or an anonymous function to target the results. Example (atom) def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; baz / 1 , [ x ] , :my_label ) |&gt; function2 ( ) end Example (anonymous function) def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; baz / 1 , [ x ] , fn -&gt; if should_i_profile? ( x ) , do : :my_label , else : :nok end ) |&gt; function2 ( ) end Then in the ezprofiler console: waiting .. ( 4 ) &gt; c my_label waiting .. ( 5 ) &gt; Code profiling enabled with a label of :my_label waiting .. ( 5 ) &gt; Got a start profiling from source code with label of :my_label NOTE: If anonymous function is used it must return an atom (label) to allow profiling ot the atom :nok to not profile. NOTE: It is advisable to filter results with --mf or the u option in the ezprofiler console","ref":"EZProfiler.CodeProfiler.html#pipe_profiling/4","title":"EZProfiler.CodeProfiler.pipe_profiling/4","type":"function"},{"doc":"Starts profiling a block of code, must call EZProfiler.CodeProfiler.stop_code_profiling() to stop and present the results. Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . start_code_profiling ( ) bar ( x ) baz ( y ) EZProfiler.CodeProfiler . stop_code_profiling ( ) end","ref":"EZProfiler.CodeProfiler.html#start_code_profiling/0","title":"EZProfiler.CodeProfiler.start_code_profiling/0","type":"function"},{"doc":"Starts profiling a block of code using a label (atom) or an anonymous function to target the results. Example (atom) def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . start_code_profiling ( :my_label ) bar ( x ) baz ( y ) EZProfiler.CodeProfiler . stop_code_profiling ( ) end Example (anonymous function) EZProfiler.CodeProfiler . start_code_profiling ( fn -&gt; if should_i_profile? ( foo ) , do : :my_label , else : :nok end ) case do_send_email ( email , private_key ) do :ok -&gt; EZProfiler.CodeProfiler . stop_code_profiling ( ) Then in the ezprofiler console: waiting .. ( 4 ) &gt; c my_label waiting .. ( 5 ) &gt; Code profiling enabled with a label of :my_label waiting .. ( 5 ) &gt; Got a start profiling from source code with label of :my_label NOTE: If anonymous function is used it must return an atom (label) to allow profiling ot the atom :nok to not profile.","ref":"EZProfiler.CodeProfiler.html#start_code_profiling/1","title":"EZProfiler.CodeProfiler.start_code_profiling/1","type":"function"},{"doc":"Stops profiling a block oof code started with start_code_profiling(..)","ref":"EZProfiler.CodeProfiler.html#stop_code_profiling/0","title":"EZProfiler.CodeProfiler.stop_code_profiling/0","type":"function"}]